## pcl 1.7.2

=== CMakeLists.txt ===
### ---[ PCL global CMake
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 OLD) # do not use VERSION option in project() command
endif()

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "possible configurations" FORCE)

# In case the user does not setup CMAKE_BUILD_TYPE, assume it's RelWithDebInfo
if("${CMAKE_BUILD_TYPE}" STREQUAL "")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type default to RelWithDebInfo, set to Release to improve performance" FORCE)
endif("${CMAKE_BUILD_TYPE}" STREQUAL "")

project(PCL)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

### ---[ Find universal dependencies
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/" ${CMAKE_MODULE_PATH})

# ---[ Include pkgconfig
include (FindPkgConfig)

# ---[ Release/Debug specific flags
if(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
  add_definitions("-DBOOST_DISABLE_ASSERTS -DEIGEN_NO_DEBUG")
endif()
if(WIN32 AND NOT MINGW)
  if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "_debug")
  endif()
  if(NOT DEFINED CMAKE_RELEASE_POSTFIX)
    set(CMAKE_RELEASE_POSTFIX "_release")
  endif()
  if(NOT DEFINED CMAKE_RELWITHDEBINFO_POSTFIX)
    set(CMAKE_RELWITHDEBINFO_POSTFIX "_release")
  endif()
  if(NOT DEFINED CMAKE_MINSIZEREL_POSTFIX)
    set(CMAKE_MINSIZEREL_POSTFIX "_release")
  endif()
endif()

# ---[ special maintainer mode
SET(CMAKE_CXX_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C++ compiler during maintainer builds."
    FORCE)
SET(CMAKE_C_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C compiler during maintainer builds."
    FORCE)
SET(CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used for linking binaries during maintainer builds."
    FORCE)
SET(CMAKE_SHARED_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used by the shared libraries linker during maintainer builds."
    FORCE)
MARK_AS_ADVANCED(
    CMAKE_CXX_FLAGS_MAINTAINER
    CMAKE_C_FLAGS_MAINTAINER
    CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    CMAKE_SHARED_LINKER_FLAGS_MAINTAINER )
# Update the documentation string of CMAKE_BUILD_TYPE for GUIs
SET(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Maintainer."
    FORCE)

# ---[ Android check
if (ANDROID)
  set (PCL_SHARED_LIBS OFF)
  message ("PCL shared libs on Android must be: ${PCL_SHARED_LIBS}")
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_verbosity.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_targets.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_options.cmake")

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cmake/custom_output.sh")
endif(CMAKE_TIMING_VERBOSE AND UNIX)

# check for SSE flags
include("${PCL_SOURCE_DIR}/cmake/pcl_find_sse.cmake")
if (PCL_ENABLE_SSE)
  PCL_CHECK_FOR_SSE()
endif (PCL_ENABLE_SSE)

# ---[ Unix/Darwin/Windows specific flags
if(CMAKE_COMPILER_IS_GNUCXX)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unknown-pragmas -fno-strict-aliasing -Wno-format-extra-args -Wno-sign-compare -Wno-invalid-offsetof -Wno-conversion ${SSE_FLAGS}")

    # Enable -Wabi for GCC > 4.3, and -Wno-deprecated for GCC < 4.3
    # to disable a lot of warnings which are not fixable
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    if (GCC_VERSION VERSION_GREATER 4.3)
      message(STATUS "-- GCC > 4.3 found, enabling -Wabi")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wabi")
    else()
      message(STATUS "-- GCC < 4.3 found, enabling -Wno-deprecated")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
    endif ()
  endif()

  if(NOT ANDROID)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif(NOT ANDROID)

  if(WIN32)
    if(PCL_SHARED_LIBS)
      SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--export-all-symbols -Wl,--enable-auto-import")
      if (MINGW)
        add_definitions("-DBOOST_THREAD_USE_LIB")
      endif()
    else(PCL_SHARED_LIBS)
      add_definitions("-DBOOST_LIB_DIAGNOSTIC -DBOOST_THREAD_USE_LIB")
    endif(PCL_SHARED_LIBS)
  endif()
endif()

if(MSVC)
  SET(CMAKE_COMPILER_IS_MSVC 1)
  add_definitions ("-DBOOST_ALL_NO_LIB -D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DNOMINMAX /bigobj")
  if("${CMAKE_CXX_FLAGS}" STREQUAL " /DWIN32 /D_WINDOWS /W3 /GR /EHsc")	# Check against default flags
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /EHsc /fp:precise /wd4800 /wd4521 /wd4251 /wd4275 /wd4305 /wd4355 ${SSE_FLAGS}")

    # Add extra code generation/link optimizations
    if(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
      SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
      SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
      SET(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
    endif(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
    # /MANIFEST:NO") # please, don't disable manifest generation, otherwise crash at start for vs2008

    if( MSVC_VERSION GREATER 1500 AND ${CMAKE_VERSION} VERSION_GREATER "2.8.6")
      include(ProcessorCount)
      ProcessorCount(N)
      if(NOT N EQUAL 0)
        SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP${N} ")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP${N} ")
      endif()
    endif()
  endif()
endif()

if (__COMPILER_PATHSCALE)
  SET(CMAKE_COMPILER_IS_PATHSCALE 1)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wno-uninitialized -zerouv -pthread -mp")
  endif()
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  SET(CMAKE_COMPILER_IS_CLANG 1)
  if("${CMAKE_C_FLAGS}" STREQUAL "")
    SET(CMAKE_C_FLAGS "-Qunused-arguments")
  endif()
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-ftemplate-depth=1024 -Qunused-arguments -Wno-invalid-offsetof ${SSE_FLAGS}") # Unfortunately older Clang versions do not have this: -Wno-unnamed-type-template-args
    if(APPLE AND WITH_CUDA AND CUDA_FOUND)
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libstdc++")
    endif()
  endif()
  SET(CLANG_LIBRARIES "stdc++")
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_utils.cmake")
set(PCL_VERSION 1.7.2 CACHE STRING "PCL version")
DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

if(WIN32)
  set(PCL_RESOURCES_DIR "${PCL_SOURCE_DIR}/resources")
  set(PCL_POINTCLOUDS_DIR "${PCL_RESOURCES_DIR}/pointclouds")
endif(WIN32)

set(PCL_OUTPUT_LIB_DIR "${PCL_BINARY_DIR}/${LIB_INSTALL_DIR}")
set(PCL_OUTPUT_BIN_DIR "${PCL_BINARY_DIR}/${BIN_INSTALL_DIR}")
make_directory("${PCL_OUTPUT_LIB_DIR}")
make_directory("${PCL_OUTPUT_BIN_DIR}")
if(WIN32)
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
  endforeach(config)
else(WIN32)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
endif(WIN32)

# Add an "uninstall" target
configure_file("${PCL_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
               "${PCL_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P
                  "${PCL_BINARY_DIR}/uninstall_target.cmake")

###
# this is copy paste form http://www.itk.org/Wiki/CMake_RPATH_handling
# in order to always make a full statement RPATH
###
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" is_system_dir)
IF("${is_system_dir}" STREQUAL "-1")
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
ENDIF("${is_system_dir}" STREQUAL "-1")

### ---[ Find universal dependencies
# the gcc-4.2.1 coming with MacOS X is not compatible with the OpenMP pragmas we use, so disabling OpenMP for it
if((NOT APPLE) OR (NOT CMAKE_COMPILER_IS_GNUCXX) OR (GCC_VERSION VERSION_GREATER 4.2.1) OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
  find_package(OpenMP)
endif()
if(OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  message (STATUS "Found OpenMP")
  if(MSVC90 OR MSVC10)
    if(MSVC90)
      set(OPENMP_DLL VCOMP90)
    elseif(MSVC10)
      set(OPENMP_DLL VCOMP100)
    endif(MSVC90)
    set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /DELAYLOAD:${OPENMP_DLL}D.dll")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DELAYLOAD:${OPENMP_DLL}.dll")
  endif(MSVC90 OR MSVC10)
else(OPENMP_FOUND)
  message (STATUS "Not found OpenMP")
endif()
# Boost (required)
include("${PCL_SOURCE_DIR}/cmake/pcl_find_boost.cmake")
# Eigen (required)
find_package(Eigen REQUIRED)
include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
add_definitions(-DEIGEN_USE_NEW_STDVECTOR
                -DEIGEN_YES_I_KNOW_SPARSE_MODULE_IS_NOT_STABLE_YET)
# FLANN (required)
if(NOT PCL_SHARED_LIBS OR (WIN32 AND NOT MINGW))
  set(FLANN_USE_STATIC ON)
endif(NOT PCL_SHARED_LIBS OR (WIN32 AND NOT MINGW))
find_package(FLANN 1.7.0 REQUIRED)
include_directories(${FLANN_INCLUDE_DIRS})

# libusb-1.0
option(WITH_LIBUSB "Build USB RGBD-Camera drivers" TRUE)
if(WITH_LIBUSB)
  find_package(libusb-1.0)
  if(LIBUSB_1_FOUND)
    include_directories("${LIBUSB_1_INCLUDE_DIR}")
  endif(LIBUSB_1_FOUND)
endif(WITH_LIBUSB)

# OpenNI
option(WITH_OPENNI "OpenNI driver support" TRUE)
if(WITH_OPENNI)
  find_package(OpenNI)
  if (OPENNI_FOUND)
    set(HAVE_OPENNI ON)
    include_directories(SYSTEM ${OPENNI_INCLUDE_DIRS})
  endif(OPENNI_FOUND)
endif(WITH_OPENNI)

# OpenNI 2
option(WITH_OPENNI2 "OpenNI 2 driver support" TRUE)
if(WITH_OPENNI2)
  find_package(OpenNI2)
  if (OPENNI2_FOUND)
    set(HAVE_OPENNI2 ON)
    include_directories(SYSTEM ${OPENNI2_INCLUDE_DIRS})
  endif(OPENNI2_FOUND)
endif(WITH_OPENNI2)

# Fotonic (FZ_API)
option(WITH_FZAPI "Build Fotonic Camera support" TRUE)
if(WITH_FZAPI)
  find_package(FZAPI)
  if (FZAPI_FOUND)
    set(HAVE_FZAPI ON)
    include_directories(SYSTEM "${FZAPI_INCLUDE_DIR}")
  endif(FZAPI_FOUND)
endif(WITH_FZAPI)

# Intel Perceptional Computing Interface (PXCAPI)
option(WITH_PXCAPI "Build PXC Device support" TRUE)
if(WITH_PXCAPI)
  find_package(PXCAPI)
  if (PXCAPI_FOUND)
    set(HAVE_PXCAPI ON)
    include_directories(SYSTEM ${PXCAPI_INCLUDE_DIRS})
  endif(PXCAPI_FOUND)
endif(WITH_PXCAPI)

# metslib
if (PKG_CONFIG_FOUND)
  pkg_check_modules(METSLIB metslib)
  if (METSLIB_FOUND)
    set (HAVE_METSLIB ON)
    include_directories(${METSLIB_INCLUDE_DIRS})
  else()
    include_directories("${PCL_SOURCE_DIR}/recognition/include/pcl/recognition/3rdparty/")
  endif()
else()
    include_directories(${PCL_SOURCE_DIR}/recognition/include/pcl/recognition/3rdparty/)
endif()

# LibPNG
option(WITH_PNG "PNG file support" TRUE)
if(WITH_PNG)
  find_package(PNG)
  if (PNG_FOUND)
    set (HAVE_PNG ON)
    include_directories("${PNG_INCLUDE_DIR}")
  endif(PNG_FOUND)
endif(WITH_PNG)

# Qhull
option(WITH_QHULL "Include convex-hull operations" TRUE)
if(WITH_QHULL)
  if(NOT PCL_SHARED_LIBS OR WIN32)
    set(QHULL_USE_STATIC ON)
  endif(NOT PCL_SHARED_LIBS OR WIN32)
  find_package(Qhull)

=== apps/CMakeLists.txt ===
set(SUBSYS_NAME apps)
set(SUBSYS_DESC "Application examples/samples that show how PCL works")
set(SUBSYS_DEPS common geometry io filters sample_consensus segmentation visualization kdtree features surface octree registration keypoints tracking search recognition)

# Find VTK
if(NOT VTK_FOUND)
    set(DEFAULT FALSE)
    set(REASON "VTK was not found.")
else(NOT VTK_FOUND)
    set(DEFAULT TRUE)
    set(REASON)
    include("${VTK_USE_FILE}")
endif(NOT VTK_FOUND)

# OpenNI found?
if(NOT OPENNI_FOUND)
    set(DEFAULT FALSE)
    set(REASON "OpenNI was not found.")
else(NOT OPENNI_FOUND)
    set(DEFAULT TRUE)
    set(REASON)
endif(NOT OPENNI_FOUND)

set(DEFAULT FALSE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni vtk)

if(build)

  include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/include")

  PCL_ADD_EXECUTABLE(pcl_test_search_speed "${SUBSYS_NAME}" src/test_search.cpp)
  target_link_libraries(pcl_test_search_speed pcl_common pcl_io pcl_search pcl_kdtree pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_nn_classification_example "${SUBSYS_NAME}" src/nn_classification_example.cpp)
  target_link_libraries(pcl_nn_classification_example pcl_common pcl_io pcl_features pcl_kdtree)

  PCL_ADD_EXECUTABLE(pcl_pyramid_surface_matching "${SUBSYS_NAME}" src/pyramid_surface_matching.cpp)
  target_link_libraries(pcl_pyramid_surface_matching pcl_common pcl_io pcl_features pcl_registration pcl_filters)

  PCL_ADD_EXECUTABLE(pcl_statistical_multiscale_interest_region_extraction_example "${SUBSYS_NAME}" src/statistical_multiscale_interest_region_extraction_example.cpp)
  target_link_libraries(pcl_statistical_multiscale_interest_region_extraction_example pcl_common pcl_io pcl_features pcl_filters)

  if(LIBUSB_1_FOUND)
    PCL_ADD_EXECUTABLE(pcl_dinast_grabber "${SUBSYS_NAME}" src/dinast_grabber_example.cpp)
    target_link_libraries(pcl_dinast_grabber pcl_common pcl_visualization pcl_io)
  endif(LIBUSB_1_FOUND)

  if (VTK_FOUND)
    PCL_ADD_EXECUTABLE(pcl_ppf_object_recognition "${SUBSYS_NAME}" src/ppf_object_recognition.cpp)
    target_link_libraries(pcl_ppf_object_recognition pcl_common pcl_io pcl_filters pcl_features pcl_registration pcl_visualization pcl_sample_consensus pcl_segmentation)

    PCL_ADD_EXECUTABLE(pcl_multiscale_feature_persistence_example "${SUBSYS_NAME}" src/multiscale_feature_persistence_example.cpp)
    target_link_libraries(pcl_multiscale_feature_persistence_example pcl_common pcl_io pcl_filters pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_surfel_smoothing_test "${SUBSYS_NAME}" src/surfel_smoothing_test.cpp)
    target_link_libraries(pcl_surfel_smoothing_test pcl_common pcl_io pcl_surface pcl_filters pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_feature_matching "${SUBSYS_NAME}" src/feature_matching.cpp)
    target_link_libraries(pcl_feature_matching pcl_common pcl_io pcl_registration pcl_keypoints pcl_sample_consensus pcl_visualization pcl_search pcl_features pcl_kdtree pcl_surface pcl_segmentation)

    PCL_ADD_EXECUTABLE(pcl_convolve "${SUBSYS_NAME}" src/convolve.cpp)
    target_link_libraries(pcl_convolve pcl_common pcl_io pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_pcd_organized_multi_plane_segmentation "${SUBSYS_NAME}" src/pcd_organized_multi_plane_segmentation.cpp)
    target_link_libraries(pcl_pcd_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

    if (QHULL_FOUND)
        PCL_ADD_EXECUTABLE(pcl_pcd_select_object_plane "${SUBSYS_NAME}" src/pcd_select_object_plane.cpp)
        target_link_libraries(pcl_pcd_select_object_plane pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_surface)
    endif()

#    PCL_ADD_EXECUTABLE(pcl_convolve "${SUBSYS_NAME}" src/convolve.cpp)
#    target_link_libraries(pcl_convolve pcl_common pcl_io pcl_visualization)

    if (QT4_FOUND AND VTK_USE_QVTK)

      # Manual registration demo
      QT4_WRAP_UI(manual_registration_ui src/manual_registration/manual_registration.ui)
      QT4_WRAP_CPP(manual_registration_moc include/pcl/apps/manual_registration.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_manual_registration "${SUBSYS_NAME}" ${manual_registration_ui} ${manual_registration_moc} src/manual_registration/manual_registration.cpp)
      target_link_libraries(pcl_manual_registration pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QVTK_LIBRARY} ${QT_LIBRARIES})

      QT4_WRAP_UI(pcd_video_player_ui src/pcd_video_player/pcd_video_player.ui)
      QT4_WRAP_CPP(pcd_video_player_moc include/pcl/apps/pcd_video_player.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_pcd_video_player "${SUBSYS_NAME}" ${pcd_video_player_ui} ${pcd_video_player_moc} src/pcd_video_player/pcd_video_player.cpp)
      target_link_libraries(pcl_pcd_video_player pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QVTK_LIBRARY} ${QT_LIBRARIES})

    endif (QT4_FOUND AND VTK_USE_QVTK)

    if (OPENNI_FOUND AND BUILD_OPENNI)

#      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_grab_frame "${SUBSYS_NAME}" src/openni_grab_frame.cpp)
#      target_link_libraries(pcl_openni_grab_frame pcl_common pcl_io pcl_visualization)

#      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_grab_images "${SUBSYS_NAME}" src/openni_grab_images.cpp)
#      target_link_libraries(pcl_openni_grab_images pcl_common pcl_io pcl_visualization)


      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_fast_mesh "${SUBSYS_NAME}" src/openni_fast_mesh.cpp)
      target_link_libraries(pcl_openni_fast_mesh pcl_common pcl_io pcl_visualization pcl_surface)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_voxel_grid "${SUBSYS_NAME}" src/openni_voxel_grid.cpp)
      target_link_libraries(pcl_openni_voxel_grid pcl_common pcl_io pcl_filters pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_octree_compression "${SUBSYS_NAME}" src/openni_octree_compression.cpp)
      target_link_libraries(pcl_openni_octree_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)

      if(HAVE_PNG)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_organized_compression "${SUBSYS_NAME}" src/openni_organized_compression.cpp)
        target_link_libraries(pcl_openni_organized_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)
      endif(HAVE_PNG)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_shift_to_depth_conversion "${SUBSYS_NAME}" src/openni_shift_to_depth_conversion.cpp)
      target_link_libraries(pcl_openni_shift_to_depth_conversion pcl_common pcl_visualization)

      PCL_ADD_EXECUTABLE(pcl_openni_mobile_server "${SUBSYS_NAME}" src/openni_mobile_server.cpp)
      target_link_libraries(pcl_openni_mobile_server pcl_common pcl_io pcl_filters pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_planar_segmentation "${SUBSYS_NAME}" src/openni_planar_segmentation.cpp)
      target_link_libraries(pcl_openni_planar_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_organized_multi_plane_segmentation "${SUBSYS_NAME}" src/openni_organized_multi_plane_segmentation.cpp)
      target_link_libraries(pcl_openni_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_ii_normal_estimation "${SUBSYS_NAME}" src/openni_ii_normal_estimation.cpp)
      target_link_libraries(pcl_openni_ii_normal_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_feature_persistence "${SUBSYS_NAME}" src/openni_feature_persistence.cpp)
      target_link_libraries(pcl_openni_feature_persistence pcl_common pcl_io pcl_filters pcl_visualization pcl_features)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_mls_smoothing "${SUBSYS_NAME}" src/openni_mls_smoothing.cpp)
      target_link_libraries(pcl_openni_mls_smoothing pcl_common pcl_io pcl_surface pcl_visualization)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_change_viewer "${SUBSYS_NAME}" src/openni_change_viewer.cpp)
      target_link_libraries(pcl_openni_change_viewer pcl_common pcl_io pcl_kdtree pcl_octree pcl_visualization pcl_filters)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_uniform_sampling "${SUBSYS_NAME}" src/openni_uniform_sampling.cpp)
      target_link_libraries(pcl_openni_uniform_sampling pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface pcl_keypoints)

      PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_boundary_estimation "${SUBSYS_NAME}" src/openni_boundary_estimation.cpp)
      target_link_libraries(pcl_openni_boundary_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

      if (QT4_FOUND AND VTK_USE_QVTK)
        # OpenNI Passthrough application demo
        QT4_WRAP_UI(openni_passthrough_ui src/openni_passthrough.ui)
        QT4_WRAP_CPP(openni_passthrough_moc include/pcl/apps/openni_passthrough.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE(pcl_openni_passthrough "${SUBSYS_NAME}" ${openni_passthrough_ui} ${openni_passthrough_moc} src/openni_passthrough.cpp)
        target_link_libraries(pcl_openni_passthrough pcl_common pcl_io pcl_filters pcl_visualization ${QVTK_LIBRARY} ${QT_LIBRARIES})

        # OpenNI Organized Connected Component application demo
        QT4_WRAP_UI(organized_segmentation_demo_ui src/organized_segmentation_demo.ui)
        QT4_WRAP_CPP(organized_segmentation_demo_moc include/pcl/apps/organized_segmentation_demo.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_organized_segmentation_demo "${SUBSYS_NAME}" ${organized_segmentation_demo_ui} ${organized_segmentation_demo_moc} src/organized_segmentation_demo.cpp)
        target_link_libraries(pcl_organized_segmentation_demo pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QVTK_LIBRARY} ${QT_LIBRARIES})

        # Database processing (integration) demo
#        QT4_WRAP_UI(db_proc_ui src/db_proc/db_proc.ui)
#        QT4_WRAP_CPP(db_proc_moc include/pcl/apps/db_proc.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)
#        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_db_proc "${SUBSYS_NAME}" ${db_proc_ui} ${db_proc_moc} src/db_proc/db_proc.cpp)
#        target_link_libraries(pcl_db_proc pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QVTK_LIBRARY} ${QT_LIBRARIES})

      endif ()

      set(incs
        include/pcl/${SUBSYS_NAME}/render_views_tesselated_sphere.h
        include/pcl/${SUBSYS_NAME}/timer.h)
      set(srcs src/render_views_tesselated_sphere.cpp)

      if (QHULL_FOUND)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_3d_convex_hull "${SUBSYS_NAME}" src/openni_3d_convex_hull.cpp)
        target_link_libraries(pcl_openni_3d_convex_hull pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_3d_concave_hull "${SUBSYS_NAME}" src/openni_3d_concave_hull.cpp)
        target_link_libraries(pcl_openni_3d_concave_hull pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_openni_tracking "${SUBSYS_NAME}" src/openni_tracking.cpp)

=== common/CMakeLists.txt ===
set(SUBSYS_NAME common)
set(SUBSYS_DESC "Point cloud common library")
set(SUBSYS_DEPS)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} EXT_DEPS eigen boost)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(range_image_incs
        include/pcl/range_image/bearing_angle_image.h
        include/pcl/range_image/range_image.h
        include/pcl/range_image/range_image_planar.h
        include/pcl/range_image/range_image_spherical.h
        )
  
    set(range_image_incs_impl
        include/pcl/range_image/impl/range_image.hpp
        include/pcl/range_image/impl/range_image_planar.hpp
        include/pcl/range_image/impl/range_image_spherical.hpp
        )

    set(range_image_srcs
        src/bearing_angle_image.cpp
        src/range_image.cpp
        src/range_image_planar.cpp
        )

    set(srcs 
        src/point_types.cpp
        src/pcl_base.cpp
        src/io.cpp
        src/common.cpp
        src/correspondence.cpp
        src/distances.cpp
        src/parse.cpp
        src/poses_from_matches.cpp
        src/print.cpp
        src/projection_matrix.cpp
        src/time_trigger.cpp
        src/gaussian.cpp
        ${range_image_srcs}
        )

    set(incs 
        include/pcl/correspondence.h
        include/pcl/exceptions.h
        include/pcl/pcl_base.h
        include/pcl/pcl_exports.h
        include/pcl/pcl_macros.h
        include/pcl/point_cloud.h
        include/pcl/point_traits.h
        include/pcl/point_types_conversion.h
        include/pcl/point_representation.h
        include/pcl/point_types.h
        include/pcl/for_each_type.h
        include/pcl/pcl_tests.h
        include/pcl/cloud_iterator.h
        include/pcl/TextureMesh.h
        include/pcl/PCLPointField.h
        include/pcl/PCLPointCloud2.h
        include/pcl/PCLImage.h
        include/pcl/PCLHeader.h
        include/pcl/ModelCoefficients.h
        include/pcl/PolygonMesh.h
        include/pcl/Vertices.h
        include/pcl/PointIndices.h
        include/pcl/sse.h
        include/pcl/PCLPointField.h
        include/pcl/PCLPointCloud2.h
        include/pcl/PCLImage.h
        include/pcl/PCLHeader.h
        include/pcl/ModelCoefficients.h
        include/pcl/PolygonMesh.h
        include/pcl/Vertices.h
        include/pcl/PointIndices.h
        include/pcl/register_point_struct.h
        include/pcl/conversions.h
        )

    set(common_incs 
        include/pcl/common/boost.h
        include/pcl/common/angles.h
        include/pcl/common/bivariate_polynomial.h
        include/pcl/common/centroid.h
        include/pcl/common/concatenate.h
        include/pcl/common/common.h
        include/pcl/common/common_headers.h
        include/pcl/common/distances.h
        include/pcl/common/eigen.h
        include/pcl/common/copy_point.h
        include/pcl/common/io.h
        include/pcl/common/file_io.h
        include/pcl/common/intersections.h
        include/pcl/common/norms.h
        include/pcl/common/piecewise_linear_function.h
        include/pcl/common/polynomial_calculations.h
        include/pcl/common/poses_from_matches.h
        include/pcl/common/time.h
        include/pcl/common/time_trigger.h
        include/pcl/common/transforms.h
        include/pcl/common/transformation_from_correspondences.h
        include/pcl/common/vector_average.h
        include/pcl/common/pca.h
        include/pcl/common/point_tests.h
        include/pcl/common/synchronizer.h
        include/pcl/common/utils.h
        include/pcl/common/geometry.h
        include/pcl/common/gaussian.h
        include/pcl/common/point_operators.h
        include/pcl/common/spring.h
        include/pcl/common/intensity.h
        include/pcl/common/random.h
        include/pcl/common/generate.h
        include/pcl/common/projection_matrix.h
        include/pcl/register_point_struct.h
        include/pcl/conversions.h
        )

    set(common_incs_impl
        include/pcl/common/impl/angles.hpp
        include/pcl/common/impl/bivariate_polynomial.hpp
        include/pcl/common/impl/centroid.hpp
        include/pcl/common/impl/common.hpp
        include/pcl/common/impl/eigen.hpp
        include/pcl/common/impl/intersections.hpp
        include/pcl/common/impl/copy_point.hpp
        include/pcl/common/impl/io.hpp
        include/pcl/common/impl/file_io.hpp
        include/pcl/common/impl/norms.hpp
        include/pcl/common/impl/piecewise_linear_function.hpp
        include/pcl/common/impl/polynomial_calculations.hpp
        include/pcl/common/impl/pca.hpp
        include/pcl/common/impl/transforms.hpp
        include/pcl/common/impl/transformation_from_correspondences.hpp
        include/pcl/common/impl/vector_average.hpp
        include/pcl/common/impl/gaussian.hpp
        include/pcl/common/impl/spring.hpp
        include/pcl/common/impl/intensity.hpp
        include/pcl/common/impl/random.hpp
        include/pcl/common/impl/generate.hpp
        include/pcl/common/impl/projection_matrix.hpp
        include/pcl/common/impl/accumulators.hpp
        )

    set(impl_incs 
        include/pcl/impl/pcl_base.hpp
        include/pcl/impl/instantiate.hpp
        include/pcl/impl/point_types.hpp
        include/pcl/impl/cloud_iterator.hpp
        )

    set(ros_incs 
        include/pcl/ros/conversions.h
        include/pcl/ros/register_point_struct.h
        )

    set(tools_incs 
        include/pcl/console/parse.h
        include/pcl/console/print.h
        include/pcl/console/time.h
        )
        
    set(kissfft_incs
        include/pcl/common/fft/_kiss_fft_guts.h
        include/pcl/common/fft/kiss_fft.h
        include/pcl/common/fft/kiss_fftr.h)
        
    set(kissfft_srcs
        src/fft/kiss_fft.c
        src/fft/kiss_fftr.c)

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${kissfft_srcs} ${incs} ${common_incs} ${impl_incs} ${ros_incs} ${tools_incs} ${kissfft_incs} ${common_incs_impl} ${range_image_incs} ${range_image_incs_impl})
    #PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${common_incs} ${impl_incs} ${ros_incs} ${tools_incs} ${common_incs_impl} ${range_image_incs} ${range_image_incs_impl})
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "" ""
        "" "" "")

    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" common ${common_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/fft ${kissfft_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/impl ${common_incs_impl})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" impl ${impl_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" ros ${ros_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" console ${tools_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image ${range_image_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image/impl ${range_image_incs_impl})

endif(build)

=== examples/CMakeLists.txt ===
set(SUBSYS_NAME examples)
set(SUBSYS_DESC "PCL examples")
set(SUBSYS_DEPS common io features search kdtree octree filters keypoints segmentation sample_consensus outofcore geometry)

set(DEFAULT FALSE)
set(REASON "Code examples are disabled by default.")
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ${DEFAULT} ${REASON})
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})

if (build)
    include_directories(${PCL_INCLUDE_DIRS})
    # This looks for all examples/XXX/CMakeLists.txt
    file (GLOB examples_sbudirs */CMakeLists.txt)
    # Extract only relevant XXX and append it to PCL_EXAMPLES_SUBDIRS
    foreach(subdir ${examples_sbudirs})
        # PATH of get_filename_component has problem dealing with windows shared folders "//xxx.xxx.xxx.xxx/folder"
        # Check here for the discussion: http://www.pcl-developers.org/Small-hack-to-get-filename-component-td5706691.html
        # Modified by Yangyan Li(yangyan.lee@gmail.com)
        # get_filename_component (dir ${subdir} PATH)
        get_filename_component (absolute ${subdir} ABSOLUTE)
        get_filename_component (name ${subdir} NAME)
        STRING(REGEX REPLACE ${name} "" dir ${absolute})
        list(APPEND PCL_EXAMPLES_SUBDIRS ${dir})
    endforeach(subdir)
    # Display the found subdirectories
    message (STATUS "PCL_EXAMPLES_SUBDIRS ${PCL_EXAMPLES_SUBDIRS}")
    # Add the subdirectories
    foreach(subdir ${PCL_EXAMPLES_SUBDIRS})
    add_subdirectory(${subdir})
    endforeach(subdir)
endif (build)

=== features/CMakeLists.txt ===
set(SUBSYS_NAME features)
set(SUBSYS_DESC "Point cloud features library")
set(SUBSYS_DEPS common search kdtree octree filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

    set(incs
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/eigen.h"
        "include/pcl/${SUBSYS_NAME}/board.h"
        "include/pcl/${SUBSYS_NAME}/cppf.h"
        "include/pcl/${SUBSYS_NAME}/cvfh.h"
        "include/pcl/${SUBSYS_NAME}/our_cvfh.h"
        "include/pcl/${SUBSYS_NAME}/crh.h"
        "include/pcl/${SUBSYS_NAME}/don.h"
        "include/pcl/${SUBSYS_NAME}/feature.h"
        "include/pcl/${SUBSYS_NAME}/fpfh.h"
        "include/pcl/${SUBSYS_NAME}/fpfh_omp.h"
        "include/pcl/${SUBSYS_NAME}/gfpfh.h"
        "include/pcl/${SUBSYS_NAME}/integral_image2D.h"
        "include/pcl/${SUBSYS_NAME}/integral_image_normal.h"
        "include/pcl/${SUBSYS_NAME}/intensity_gradient.h"
        "include/pcl/${SUBSYS_NAME}/intensity_spin.h"
        "include/pcl/${SUBSYS_NAME}/linear_least_squares_normal.h"
        "include/pcl/${SUBSYS_NAME}/moment_invariants.h"
        "include/pcl/${SUBSYS_NAME}/moment_of_inertia_estimation.h"
        "include/pcl/${SUBSYS_NAME}/multiscale_feature_persistence.h"
        "include/pcl/${SUBSYS_NAME}/narf.h"
        "include/pcl/${SUBSYS_NAME}/narf_descriptor.h"
        "include/pcl/${SUBSYS_NAME}/normal_3d.h"
        "include/pcl/${SUBSYS_NAME}/normal_3d_omp.h"
        "include/pcl/${SUBSYS_NAME}/normal_based_signature.h"
        "include/pcl/${SUBSYS_NAME}/pfh.h"
        "include/pcl/${SUBSYS_NAME}/pfh_tools.h"
        "include/pcl/${SUBSYS_NAME}/pfhrgb.h"
        "include/pcl/${SUBSYS_NAME}/ppf.h"
        "include/pcl/${SUBSYS_NAME}/ppfrgb.h"
        "include/pcl/${SUBSYS_NAME}/shot.h"
        "include/pcl/${SUBSYS_NAME}/shot_lrf.h"
        "include/pcl/${SUBSYS_NAME}/shot_lrf_omp.h"
        "include/pcl/${SUBSYS_NAME}/shot_omp.h"
        "include/pcl/${SUBSYS_NAME}/spin_image.h"
        "include/pcl/${SUBSYS_NAME}/principal_curvatures.h"
        "include/pcl/${SUBSYS_NAME}/rift.h"
        "include/pcl/${SUBSYS_NAME}/rops_estimation.h"
        #"include/pcl/${SUBSYS_NAME}/rsd.h"
        "include/pcl/${SUBSYS_NAME}/statistical_multiscale_interest_region_extraction.h"
        "include/pcl/${SUBSYS_NAME}/vfh.h"
        "include/pcl/${SUBSYS_NAME}/esf.h"
        "include/pcl/${SUBSYS_NAME}/3dsc.h"
        "include/pcl/${SUBSYS_NAME}/usc.h"
        "include/pcl/${SUBSYS_NAME}/boundary.h"
        "include/pcl/${SUBSYS_NAME}/range_image_border_extractor.h"
        )

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/board.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/cppf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/cvfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/our_cvfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/crh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/don.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/feature.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/fpfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/fpfh_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/gfpfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/integral_image2D.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/integral_image_normal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/intensity_gradient.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/intensity_spin.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/linear_least_squares_normal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/moment_invariants.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/moment_of_inertia_estimation.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/multiscale_feature_persistence.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/narf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_3d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_3d_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_based_signature.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/pfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/pfhrgb.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ppf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ppfrgb.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot_lrf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot_lrf_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shot_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/spin_image.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/principal_curvatures.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/rift.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/rops_estimation.hpp"
        #"include/pcl/${SUBSYS_NAME}/impl/rsd.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/statistical_multiscale_interest_region_extraction.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/vfh.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/esf.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/3dsc.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/usc.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/boundary.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/range_image_border_extractor.hpp"
        )

    set(srcs
        src/board.cpp
        src/boundary.cpp
        src/cppf.cpp
        src/cvfh.cpp
        src/our_cvfh.cpp
        src/crh.cpp
        src/don.cpp
        src/fpfh.cpp
        src/gfpfh.cpp
        src/integral_image_normal.cpp
        src/intensity_gradient.cpp
        src/intensity_spin.cpp
        src/linear_least_squares_normal.cpp
        src/moment_invariants.cpp
        src/moment_of_inertia_estimation.cpp
        src/multiscale_feature_persistence.cpp
        src/narf.cpp
        src/normal_3d.cpp
        src/normal_based_signature.cpp
        src/pfh.cpp
        src/ppf.cpp
        src/shot.cpp
        src/shot_lrf.cpp
        src/spin_image.cpp
        src/principal_curvatures.cpp
        src/rift.cpp
        src/rops_estimation.cpp
        #src/rsd.cpp
        src/statistical_multiscale_interest_region_extraction.cpp
        src/vfh.cpp
        src/esf.cpp        
        src/3dsc.cpp
        src/usc.cpp
        src/range_image_border_extractor.cpp
       )
	
    if(MSVC)
      # Workaround to aviod hitting the MSVC 4GB linker memory limit when building pcl_features.
      # Disable whole program optimization (/GL) and link-time code generation (/LTCG).
      string(REPLACE "/GL" "" CMAKE_CXX_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
      string(REPLACE "/LTCG" "" CMAKE_SHARED_LINKER_FLAGS_RELEASE ${CMAKE_SHARED_LINKER_FLAGS_RELEASE}) 
    endif(MSVC)
	
    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}" pcl_common pcl_search pcl_kdtree pcl_octree pcl_filters)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")
    # Install headers
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== filters/CMakeLists.txt ===
set(SUBSYS_NAME filters)
set(SUBSYS_DESC "Point cloud filters library")
set(SUBSYS_DEPS common sample_consensus search kdtree octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(srcs
        src/conditional_removal.cpp
        src/crop_box.cpp
        src/extract_indices.cpp
        src/filter.cpp
        src/filter_indices.cpp
        src/passthrough.cpp
        src/shadowpoints.cpp
        src/project_inliers.cpp
        src/radius_outlier_removal.cpp
        src/random_sample.cpp
        src/normal_space.cpp
        src/sampling_surface_normal.cpp
        src/statistical_outlier_removal.cpp
        src/voxel_grid.cpp
        src/approximate_voxel_grid.cpp
        src/bilateral.cpp
        src/fast_bilateral.cpp
        src/fast_bilateral_omp.cpp
        src/crop_hull.cpp
        src/voxel_grid_covariance.cpp
	    src/voxel_grid_label.cpp
        src/frustum_culling.cpp
        src/covariance_sampling.cpp
        src/median_filter.cpp
	src/voxel_grid_occlusion_estimation.cpp
	    src/normal_refinement.cpp
        src/grid_minimum.cpp
        src/morphological_filter.cpp
        src/local_maximum.cpp
        src/model_outlier_removal.cpp
        )

    set(incs
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/conditional_removal.h"
        "include/pcl/${SUBSYS_NAME}/crop_box.h"
        "include/pcl/${SUBSYS_NAME}/clipper3D.h"
        "include/pcl/${SUBSYS_NAME}/plane_clipper3D.h"
        "include/pcl/${SUBSYS_NAME}/box_clipper3D.h"
        "include/pcl/${SUBSYS_NAME}/crop_hull.h"
        "include/pcl/${SUBSYS_NAME}/extract_indices.h"
        "include/pcl/${SUBSYS_NAME}/filter.h"
        "include/pcl/${SUBSYS_NAME}/filter_indices.h"
        "include/pcl/${SUBSYS_NAME}/passthrough.h"
        "include/pcl/${SUBSYS_NAME}/shadowpoints.h"
        "include/pcl/${SUBSYS_NAME}/project_inliers.h"
        "include/pcl/${SUBSYS_NAME}/radius_outlier_removal.h"
        "include/pcl/${SUBSYS_NAME}/random_sample.h"
        "include/pcl/${SUBSYS_NAME}/normal_space.h"
        "include/pcl/${SUBSYS_NAME}/sampling_surface_normal.h"
        "include/pcl/${SUBSYS_NAME}/statistical_outlier_removal.h"
        "include/pcl/${SUBSYS_NAME}/voxel_grid.h"
        "include/pcl/${SUBSYS_NAME}/approximate_voxel_grid.h"
        "include/pcl/${SUBSYS_NAME}/bilateral.h"
        "include/pcl/${SUBSYS_NAME}/fast_bilateral.h"
        "include/pcl/${SUBSYS_NAME}/fast_bilateral_omp.h"
        "include/pcl/${SUBSYS_NAME}/voxel_grid_covariance.h"
        "include/pcl/${SUBSYS_NAME}/convolution.h"
        "include/pcl/${SUBSYS_NAME}/convolution_3d.h"
        "include/pcl/${SUBSYS_NAME}/voxel_grid_label.h"
        "include/pcl/${SUBSYS_NAME}/voxel_grid_occlusion_estimation.h"
        "include/pcl/${SUBSYS_NAME}/frustum_culling.h"
        "include/pcl/${SUBSYS_NAME}/covariance_sampling.h"
        "include/pcl/${SUBSYS_NAME}/median_filter.h"
        "include/pcl/${SUBSYS_NAME}/normal_refinement.h"
        "include/pcl/${SUBSYS_NAME}/grid_minimum.h"
        "include/pcl/${SUBSYS_NAME}/morphological_filter.h"
        "include/pcl/${SUBSYS_NAME}/local_maximum.h"
        "include/pcl/${SUBSYS_NAME}/model_outlier_removal.h"
        )

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/conditional_removal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/crop_box.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/crop_hull.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/plane_clipper3D.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/box_clipper3D.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/extract_indices.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/filter.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/filter_indices.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/passthrough.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/shadowpoints.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/project_inliers.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/radius_outlier_removal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/random_sample.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_space.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/sampling_surface_normal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/statistical_outlier_removal.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/voxel_grid.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/approximate_voxel_grid.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/bilateral.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/fast_bilateral.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/fast_bilateral_omp.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/voxel_grid_covariance.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/convolution.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/convolution_3d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/voxel_grid_occlusion_estimation.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/frustum_culling.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/covariance_sampling.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/median_filter.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/normal_refinement.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/grid_minimum.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/morphological_filter.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/local_maximum.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/model_outlier_removal.hpp"
        )

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}" pcl_common pcl_sample_consensus pcl_search pcl_kdtree pcl_octree)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== io/CMakeLists.txt ===
set(SUBSYS_NAME io)
set(SUBSYS_DESC "Point cloud IO library")
set(SUBSYS_DEPS common octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
if(WIN32)
    PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 pcap png vtk)
else(WIN32)
    PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 pcap png vtk libusb-1.0)
endif(WIN32)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
  set(IMAGE_INCLUDES
    include/pcl/io/image_metadata_wrapper.h
    include/pcl/io/image.h
    include/pcl/io/image_rgb24.h
    include/pcl/io/image_yuv422.h
    include/pcl/io/image_ir.h
    include/pcl/io/image_depth.h
  )

  set(IMAGE_SOURCES
    src/image_rgb24.cpp
    src/image_yuv422.cpp
    src/image_ir.cpp
    src/image_depth.cpp
  )

    ## OpenNI 2.x
    OPTION(BUILD_OPENNI2 "Build the OpenNI 2 Grabber." OFF)
    MARK_AS_ADVANCED(BUILD_OPENNI2)
    if(NOT BUILD_OPENNI2)
      # Set OPENNI2_FOUND to false locally to avoid building anything OpenNI 2 related
      # Remember that other modules (libraries) need to check explicitly for BUILD_OPENNI2
      set(OPENNI2_FOUND FALSE)
    endif()
    if(OPENNI2_FOUND)
        set(OPENNI2_GRABBER_INCLUDES
            include/pcl/io/openni2_grabber.h
            )
        set(OPENNI2_INCLUDES
            include/pcl/io/openni2/openni.h
            include/pcl/io/openni2/openni2_metadata_wrapper.h
            include/pcl/io/openni2/openni2_frame_listener.h
            include/pcl/io/openni2/openni2_timer_filter.h
            include/pcl/io/openni2/openni2_video_mode.h
            include/pcl/io/openni2/openni2_convert.h
            include/pcl/io/openni2/openni2_device.h
            include/pcl/io/openni2/openni2_device_info.h
            include/pcl/io/openni2/openni2_device_manager.h
        )

        set(OPENNI2_GRABBER_SOURCES
            src/openni2_grabber.cpp
            src/openni2/openni2_timer_filter.cpp
            src/openni2/openni2_video_mode.cpp
            src/openni2/openni2_convert.cpp
            src/openni2/openni2_device.cpp
            src/openni2/openni2_device_info.cpp
            src/openni2/openni2_device_manager.cpp
        )

      source_group("OpenNI 2\\Header Files" FILES ${OPENNI2_GRABBER_INCLUDES} ${OPENNI2_INCLUDES} ${IMAGE_INCLUDES})
      source_group("OpenNI 2\\Source Files" FILES ${OPENNI2_GRABBER_SOURCES} ${IMAGE_SOURCES})

        # Copy OpenNI2 redist directory to bin. Needed for driver modules. Only tested on Windows.
        if(MSVC)
            file(COPY ${OPENNI2_REDIST_DIR} DESTINATION ${CMAKE_BINARY_DIR}/bin PATTERN *.*)
        endif(MSVC)
    endif(OPENNI2_FOUND)

    ## OpenNI 1.x
    OPTION(BUILD_OPENNI "Build the OpenNI Grabber." ON)
    MARK_AS_ADVANCED(BUILD_OPENNI)
    if(NOT BUILD_OPENNI)
      # Set OPENNI_FOUND to false locally to avoid building anything OpenNI related
      # Remember that other modules (libraries) need to check explicitly for BUILD_OPENNI
      set(OPENNI_FOUND FALSE)
    endif()
    if(OPENNI_FOUND)
        set(OPENNI_GRABBER_INCLUDES
            include/pcl/io/openni_grabber.h
            include/pcl/io/oni_grabber.h
            )
        set(OPENNI_INCLUDES
            include/pcl/io/openni_camera/openni_shift_to_depth_conversion.h
            include/pcl/io/openni_camera/openni.h
            include/pcl/io/openni_camera/openni_depth_image.h
            include/pcl/io/openni_camera/openni_device.h
            include/pcl/io/openni_camera/openni_device_kinect.h
            include/pcl/io/openni_camera/openni_device_primesense.h
            include/pcl/io/openni_camera/openni_device_xtion.h
            include/pcl/io/openni_camera/openni_device_oni.h
            include/pcl/io/openni_camera/openni_driver.h
            include/pcl/io/openni_camera/openni_exception.h
            include/pcl/io/openni_camera/openni_image.h
            include/pcl/io/openni_camera/openni_image_bayer_grbg.h
            include/pcl/io/openni_camera/openni_image_yuv_422.h
            include/pcl/io/openni_camera/openni_image_rgb24.h
            include/pcl/io/openni_camera/openni_ir_image.h
           ${IMAGE_INCLUDES}
        )
        set(OPENNI_GRABBER_SOURCES
            src/openni_camera/openni_device.cpp
            src/openni_camera/openni_device_primesense.cpp
            src/openni_camera/openni_image_bayer_grbg.cpp
            src/openni_camera/openni_depth_image.cpp
            src/openni_camera/openni_ir_image.cpp
            src/openni_camera/openni_device_kinect.cpp
            src/openni_camera/openni_device_xtion.cpp
            src/openni_camera/openni_device_oni.cpp
            src/openni_camera/openni_driver.cpp
            src/openni_camera/openni_exception.cpp
            src/openni_camera/openni_image_yuv_422.cpp
            src/openni_camera/openni_image_rgb24.cpp
            src/openni_grabber.cpp
            src/oni_grabber.cpp
            ${IMAGE_SOURCES}
        )
    endif(OPENNI_FOUND)

    source_group("Image Headers" FILES ${IMAGE_INCLUDES})
    source_group("Image Sources" FILES ${IMAGE_SOURCES})

    if(FZAPI_FOUND)
        set(FZAPI_GRABBER_INCLUDES
            include/pcl/io/fotonic_grabber.h
            )
#        set(FZAPI_INCLUDES
#            include/pcl/io/openni_camera/openni.h
#            )
        set(FZAPI_GRABBER_SOURCES
            src/fotonic_grabber.cpp
            )
    endif(FZAPI_FOUND)

	if(PXCAPI_FOUND)
		set(PXC_GRABBER_INCLUDES
			include/pcl/io/pxc_grabber.h
			)
		set(PXC_GRABBER_SOURCES
			src/pxc_grabber.cpp
			)
	endif(PXCAPI_FOUND)

    if(LIBUSB_1_FOUND)
        set(DINAST_GRABBER_INCLUDES
            include/pcl/io/dinast_grabber.h
           )
        set(DINAST_GRABBER_SOURCES
            src/dinast_grabber.cpp
           )
    endif(LIBUSB_1_FOUND)

    if (VTK_FOUND AND NOT ANDROID)
        set(VTK_USE_FILE "${VTK_USE_FILE}" CACHE INTERNAL "VTK_USE_FILE")
        include("${VTK_USE_FILE}")
        set(VTK_IO_INCLUDES
            "include/pcl/${SUBSYS_NAME}/vtk_lib_io.h"
            "include/pcl/${SUBSYS_NAME}/png_io.h"
           )
        set(VTK_IO_INCLUDES_IMPL
            "include/pcl/${SUBSYS_NAME}/impl/vtk_lib_io.hpp"
           )
        set(VTK_IO_SOURCE
            src/vtk_lib_io.cpp
            src/png_io.cpp
           )
        set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging vtkHybrid vtkGraphics vtkRendering vtkFiltering vtkVolumeRendering)
        # Indicates that we can rely on VTK to be present
        set(VTK_DEFINES -DPCL_BUILT_WITH_VTK)
    endif ()

    set(PLY_SOURCES src/ply/ply_parser.cpp)
    set(PLY_INCLUDES
        "include/pcl/${SUBSYS_NAME}/ply/byte_order.h"
        "include/pcl/${SUBSYS_NAME}/ply/io_operators.h"
        "include/pcl/${SUBSYS_NAME}/ply/ply.h"
        "include/pcl/${SUBSYS_NAME}/ply/ply_parser.h"
       )
    PCL_ADD_LIBRARY(pcl_io_ply "${SUBSYS_NAME}" ${PLY_SOURCES} ${PLY_INCLUDES})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ply" ${PLY_INCLUDES})

    set(srcs
        src/debayer.cpp
        src/pcd_grabber.cpp
        src/pcd_io.cpp
        src/vtk_io.cpp
        src/ply_io.cpp
        src/ascii_io.cpp
        src/compression.cpp
        src/lzf.cpp
        src/lzf_image_io.cpp
        src/obj_io.cpp
        src/ifs_io.cpp
        src/image_grabber.cpp
        src/hdl_grabber.cpp
        src/robot_eye_grabber.cpp
        src/file_io.cpp
        src/io_exception.cpp
        ${VTK_IO_SOURCE}
        ${OPENNI_GRABBER_SOURCES}
        ${OPENNI2_GRABBER_SOURCES}
        ${IMAGE_SOURCES}
        ${DINAST_GRABBER_SOURCES}
        ${FZAPI_GRABBER_SOURCES}
        ${PXC_GRABBER_SOURCES}
        )
    if(PNG_FOUND)
      list(APPEND srcs
          src/libpng_wrapper.cpp
          )
    endif(PNG_FOUND)

	if(PCAP_FOUND)
	  set(PCAP_DEFINES -DHAVE_PCAP)
          include_directories(${PCAP_INCLUDE_DIRS})
	  add_definitions(${PCAP_DEFINES})
	endif(PCAP_FOUND)

    set(incs
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/eigen.h"
        "include/pcl/${SUBSYS_NAME}/debayer.h"
        "include/pcl/${SUBSYS_NAME}/file_io.h"
        "include/pcl/${SUBSYS_NAME}/lzf.h"
        "include/pcl/${SUBSYS_NAME}/lzf_image_io.h"
        "include/pcl/${SUBSYS_NAME}/io.h"
        "include/pcl/${SUBSYS_NAME}/grabber.h"
        "include/pcl/${SUBSYS_NAME}/file_grabber.h"
        "include/pcl/${SUBSYS_NAME}/pcd_grabber.h"
        "include/pcl/${SUBSYS_NAME}/pcd_io.h"
        "include/pcl/${SUBSYS_NAME}/vtk_io.h"
        "include/pcl/${SUBSYS_NAME}/ply_io.h"
        "include/pcl/${SUBSYS_NAME}/tar.h"
        "include/pcl/${SUBSYS_NAME}/obj_io.h"
        "include/pcl/${SUBSYS_NAME}/ascii_io.h"
        "include/pcl/${SUBSYS_NAME}/ifs_io.h"
        "include/pcl/${SUBSYS_NAME}/image_grabber.h"
        "include/pcl/${SUBSYS_NAME}/hdl_grabber.h"
        "include/pcl/${SUBSYS_NAME}/robot_eye_grabber.h"
        "include/pcl/${SUBSYS_NAME}/point_cloud_image_extractors.h"
        "include/pcl/${SUBSYS_NAME}/io_exception.h"
        ${VTK_IO_INCLUDES}
        ${OPENNI_GRABBER_INCLUDES}
        ${OPENNI2_GRABBER_INCLUDES}
        ${IMAGE_INCLUDES}
        ${DINAST_GRABBER_INCLUDES}
        ${FZAPI_GRABBER_INCLUDES}
        ${PXC_GRABBER_INCLUDES}
        )

    set(compression_incs
        include/pcl/compression/octree_pointcloud_compression.h
        include/pcl/compression/color_coding.h
        include/pcl/compression/compression_profiles.h
        include/pcl/compression/entropy_range_coder.h
        include/pcl/compression/point_coding.h
       )
    if(PNG_FOUND)
      list(APPEND compression_incs
          include/pcl/compression/organized_pointcloud_conversion.h
          include/pcl/compression/libpng_wrapper.h
          )
      if(OPENNI_FOUND OR OPENNI2_FOUND)
        list(APPEND compression_incs
          include/pcl/compression/organized_pointcloud_compression.h
          )
      endif(OPENNI_FOUND OR OPENNI2_FOUND)
    endif(PNG_FOUND)

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/pcd_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/lzf_image_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/synchronized_queue.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/point_cloud_image_extractors.hpp"
        include/pcl/compression/impl/entropy_range_coder.hpp
        include/pcl/compression/impl/octree_pointcloud_compression.hpp
        ${VTK_IO_INCLUDES_IMPL}
       )
    if(PNG_FOUND AND (OPENNI_FOUND OR OPENNI2_FOUND) )
     list(APPEND impl_incs
         include/pcl/compression/impl/organized_pointcloud_compression.hpp
        )
    endif(PNG_FOUND AND (OPENNI_FOUND OR OPENNI2_FOUND) )

    set(LIB_NAME "pcl_${SUBSYS_NAME}")

    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include" ${VTK_INCLUDE_DIRECTORIES})
    add_definitions(${VTK_DEFINES})
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${compression_incs} ${impl_incs} ${OPENNI_INCLUDES} ${OPENNI2_INCLUDES})
    link_directories(${VTK_LINK_DIRECTORIES})
    target_link_libraries("${LIB_NAME}" pcl_common pcl_io_ply ${VTK_LIBRARIES} )
    if(PNG_FOUND)
      target_link_libraries("${LIB_NAME}" "${PNG_LIBRARY}")
    endif(PNG_FOUND)

    if(LIBUSB_1_FOUND)
      target_link_libraries("${LIB_NAME}" ${LIBUSB_1_LIBRARIES})
    endif(LIBUSB_1_FOUND)

    if(OPENNI2_FOUND)
      target_link_libraries(${LIB_NAME} ${OPENNI2_LIBRARIES})
    endif(OPENNI2_FOUND)

    if(OPENNI_FOUND)
      target_link_libraries("${LIB_NAME}" ${OPENNI_LIBRARIES})
    endif(OPENNI_FOUND)

    if(FZAPI_FOUND)
      target_link_libraries("${LIB_NAME}" ${FZAPI_LIBS})
	  if(WIN32)
		target_link_libraries("${LIB_NAME}" Version.lib)
  	  endif(WIN32)
    endif(FZAPI_FOUND)

	if(PXCAPI_FOUND)
	  link_directories(${PXCAPI_LIB_DIRS})
	  target_link_libraries("${LIB_NAME}" ${PXCAPI_LIBS})
	endif(PXCAPI_FOUND)

    if (PCAP_FOUND)
      target_link_libraries("${LIB_NAME}" ${PCAP_LIBRARIES})
    endif(PCAP_FOUND)

    set(EXT_DEPS eigen3)

    if(OPENNI_FOUND)
      list(APPEND EXT_DEPS openni-dev)
    endif(OPENNI_FOUND)

=== keypoints/CMakeLists.txt ===
set(SUBSYS_NAME keypoints)
set(SUBSYS_DESC "Point cloud keypoints library")
set(SUBSYS_DEPS common search kdtree octree features filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(srcs
        src/narf_keypoint.cpp
        src/uniform_sampling.cpp
        src/sift_keypoint.cpp
        src/smoothed_surfaces_keypoint.cpp
        src/harris_3d.cpp
        src/harris_6d.cpp
        src/agast_2d.cpp
        src/susan.cpp
        src/iss_3d.cpp
        )
    set(incs
        "include/pcl/${SUBSYS_NAME}/keypoint.h"
        "include/pcl/${SUBSYS_NAME}/narf_keypoint.h"
        "include/pcl/${SUBSYS_NAME}/sift_keypoint.h"
        "include/pcl/${SUBSYS_NAME}/uniform_sampling.h"
        "include/pcl/${SUBSYS_NAME}/smoothed_surfaces_keypoint.h"
        "include/pcl/${SUBSYS_NAME}/agast_2d.h"
        "include/pcl/${SUBSYS_NAME}/harris_3d.h"
        "include/pcl/${SUBSYS_NAME}/harris_6d.h"
        "include/pcl/${SUBSYS_NAME}/susan.h"
        "include/pcl/${SUBSYS_NAME}/iss_3d.h"
        )
    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/keypoint.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/sift_keypoint.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/uniform_sampling.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/smoothed_surfaces_keypoint.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/agast_2d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/harris_3d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/harris_6d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/susan.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/iss_3d.hpp"
        )
    
    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}" pcl_features pcl_filters)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== octree/CMakeLists.txt ===
set(SUBSYS_NAME octree)
set(SUBSYS_DESC "Point cloud octree library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(srcs src/octree_inst.cpp
    )

    set(incs 
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/octree_base.h"
        "include/pcl/${SUBSYS_NAME}/octree_container.h"
        "include/pcl/${SUBSYS_NAME}/octree_impl.h"
        "include/pcl/${SUBSYS_NAME}/octree_nodes.h"
        "include/pcl/${SUBSYS_NAME}/octree_key.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_density.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_occupancy.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_singlepoint.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_pointvector.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_changedetector.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_voxelcentroid.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud.h"
        "include/pcl/${SUBSYS_NAME}/octree_iterator.h"
        "include/pcl/${SUBSYS_NAME}/octree_search.h"
        "include/pcl/${SUBSYS_NAME}/octree.h"
        "include/pcl/${SUBSYS_NAME}/octree2buf_base.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_adjacency.h"
        "include/pcl/${SUBSYS_NAME}/octree_pointcloud_adjacency_container.h"
        )

    set(impl_incs    
        "include/pcl/${SUBSYS_NAME}/impl/octree_base.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_pointcloud.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree2buf_base.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_iterator.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_search.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_pointcloud_voxelcentroid.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_pointcloud_adjacency.hpp"
        )

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    target_link_libraries("${LIB_NAME}")
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}"
      "${SUBSYS_DEPS}" "" "" "" "")
 
    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

endif(build)

=== outofcore/CMakeLists.txt ===
set(SUBSYS_NAME outofcore)
set(SUBSYS_DESC "Point cloud outofcore library")
set(SUBSYS_DEPS common io filters octree visualization)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(srcs
        src/cJSON.cpp
        src/outofcore_node_data.cpp
        src/outofcore_base_data.cpp
        )

    set(incs
        "include/pcl/${SUBSYS_NAME}/metadata.h"
        "include/pcl/${SUBSYS_NAME}/outofcore_base_data.h"
        "include/pcl/${SUBSYS_NAME}/outofcore_node_data.h"
        "include/pcl/${SUBSYS_NAME}/outofcore_iterator_base.h"
        "include/pcl/${SUBSYS_NAME}/outofcore_breadth_first_iterator.h"
        "include/pcl/${SUBSYS_NAME}/outofcore_depth_first_iterator.h"
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/cJSON.h"
        "include/pcl/${SUBSYS_NAME}/octree_base.h"
        "include/pcl/${SUBSYS_NAME}/octree_base_node.h"
        "include/pcl/${SUBSYS_NAME}/octree_abstract_node_container.h"
        "include/pcl/${SUBSYS_NAME}/octree_disk_container.h"
        "include/pcl/${SUBSYS_NAME}/octree_ram_container.h"
        "include/pcl/${SUBSYS_NAME}/outofcore.h"
        "include/pcl/${SUBSYS_NAME}/outofcore_impl.h"
        )

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/outofcore_breadth_first_iterator.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/outofcore_depth_first_iterator.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_base.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_base_node.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_disk_container.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/octree_ram_container.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/monitor_queue.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/lru_cache.hpp"
        )
    set(visualization_incs
        "include/pcl/${SUBSYS_NAME}/visualization/axes.h"
        "include/pcl/${SUBSYS_NAME}/visualization/camera.h"
        "include/pcl/${SUBSYS_NAME}/visualization/common.h"
        "include/pcl/${SUBSYS_NAME}/visualization/geometry.h"
        "include/pcl/${SUBSYS_NAME}/visualization/grid.h"
        "include/pcl/${SUBSYS_NAME}/visualization/object.h"
        "include/pcl/${SUBSYS_NAME}/visualization/outofcore_cloud.h"
        "include/pcl/${SUBSYS_NAME}/visualization/scene.h"
        "include/pcl/${SUBSYS_NAME}/visualization/viewport.h"
        )
    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs} ${visualization_incs})
    #PCL_ADD_SSE_FLAGS("${LIB_NAME}")
    target_link_libraries("${LIB_NAME}" pcl_common pcl_visualization ${Boost_SYSTEM_LIBRARY})
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")

    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/visualization" ${visualization_incs})

    if(BUILD_tools)
        add_subdirectory(tools)
    endif(BUILD_tools)
    
endif(build)

=== people/CMakeLists.txt ===
set(SUBSYS_NAME people)
set(SUBSYS_DESC "Point cloud people library")
set(SUBSYS_DEPS common kdtree search features sample_consensus filters io visualization geometry segmentation octree)

if(NOT VTK_FOUND)
    set(DEFAULT FALSE)
    set(REASON "VTK was not found.")
else(NOT VTK_FOUND)
    set(DEFAULT TRUE)
    set(REASON)
    set(VTK_USE_FILE "${VTK_USE_FILE}" CACHE INTERNAL "VTK_USE_FILE")
    include("${VTK_USE_FILE}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
endif(NOT VTK_FOUND)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(incs 
        "include/pcl/${SUBSYS_NAME}/ground_based_people_detection_app.h"
        "include/pcl/${SUBSYS_NAME}/head_based_subcluster.h"
        "include/pcl/${SUBSYS_NAME}/height_map_2d.h"
        "include/pcl/${SUBSYS_NAME}/person_classifier.h"
        "include/pcl/${SUBSYS_NAME}/person_cluster.h"
        "include/pcl/${SUBSYS_NAME}/hog.h"
        )

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/ground_based_people_detection_app.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/head_based_subcluster.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/height_map_2d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/person_classifier.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/person_cluster.hpp"
        )

    set(srcs
        src/hog.cpp)

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")
    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
    
    #SET_TARGET_PROPERTIES("${LIB_NAME}" PROPERTIES LINKER_LANGUAGE CXX)

    if(OPENNI_FOUND AND BUILD_OPENNI)
        PCL_ADD_EXECUTABLE_OPT_BUNDLE(pcl_ground_based_rgbd_people_detector "${SUBSYS_NAME}" apps/main_ground_based_people_detection.cpp)
        target_link_libraries(pcl_ground_based_rgbd_people_detector pcl_common pcl_kdtree pcl_search pcl_features pcl_sample_consensus pcl_filters pcl_io pcl_visualization pcl_segmentation pcl_people)
    endif()
endif(build)

=== recognition/CMakeLists.txt ===
set(SUBSYS_NAME recognition)
set(SUBSYS_DESC "Point cloud recognition library")
set(SUBSYS_DEPS common io search kdtree octree features filters registration sample_consensus)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    set(LINEMOD_INCLUDES
        "include/pcl/${SUBSYS_NAME}/linemod/line_rgbd.h"
        )
    set(LINEMOD_IMPLS
        "include/pcl/${SUBSYS_NAME}/impl/linemod/line_rgbd.hpp"
        )

    set(incs 
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/color_gradient_dot_modality.h"
        "include/pcl/${SUBSYS_NAME}/color_gradient_modality.h"
        "include/pcl/${SUBSYS_NAME}/color_modality.h"
        "include/pcl/${SUBSYS_NAME}/crh_alignment.h"
        "include/pcl/${SUBSYS_NAME}/linemod.h"
        "include/pcl/${SUBSYS_NAME}/dotmod.h"
        "include/pcl/${SUBSYS_NAME}/quantizable_modality.h"
        "include/pcl/${SUBSYS_NAME}/quantized_map.h"
        "include/pcl/${SUBSYS_NAME}/dot_modality.h"
        "include/pcl/${SUBSYS_NAME}/region_xy.h"
        "include/pcl/${SUBSYS_NAME}/mask_map.h"
        "include/pcl/${SUBSYS_NAME}/point_types.h"
        "include/pcl/${SUBSYS_NAME}/distance_map.h"
        "include/pcl/${SUBSYS_NAME}/dense_quantized_multi_mod_template.h"
        "include/pcl/${SUBSYS_NAME}/sparse_quantized_multi_mod_template.h"
        "include/pcl/${SUBSYS_NAME}/surface_normal_modality.h"
        "include/pcl/${SUBSYS_NAME}/linemod/line_rgbd.h"
        "include/pcl/${SUBSYS_NAME}/implicit_shape_model.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/auxiliary.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/hypothesis.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/model_library.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/rigid_transform_space.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/obj_rec_ransac.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/orr_graph.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree_zprojection.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/trimmed_icp.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/simple_octree.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/voxel_structure.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/bvh.h"
        )

    set(ransac_based_incs 
        "include/pcl/${SUBSYS_NAME}/ransac_based/auxiliary.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/hypothesis.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/model_library.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/rigid_transform_space.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/obj_rec_ransac.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/orr_graph.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree_zprojection.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/trimmed_icp.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/simple_octree.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/voxel_structure.h"
        "include/pcl/${SUBSYS_NAME}/ransac_based/bvh.h"
	)

    set(hv_incs
        "include/pcl/${SUBSYS_NAME}/hv/occlusion_reasoning.h"
        "include/pcl/${SUBSYS_NAME}/hv/hypotheses_verification.h"
        "include/pcl/${SUBSYS_NAME}/hv/hv_papazov.h"
        "include/pcl/${SUBSYS_NAME}/hv/hv_go.h"
        "include/pcl/${SUBSYS_NAME}/hv/greedy_verification.h"
        )

    set(cg_incs
        "include/pcl/${SUBSYS_NAME}/cg/correspondence_grouping.h"
        "include/pcl/${SUBSYS_NAME}/cg/hough_3d.h"
        "include/pcl/${SUBSYS_NAME}/cg/geometric_consistency.h"
        )

    set(impl_incs 
        "include/pcl/${SUBSYS_NAME}/impl/linemod/line_rgbd.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ransac_based/simple_octree.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ransac_based/voxel_structure.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/implicit_shape_model.hpp"
        )

    set(ransac_based_impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/ransac_based/simple_octree.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/ransac_based/voxel_structure.hpp"
	)

    set(hv_impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/hv/occlusion_reasoning.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/hv/hv_papazov.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/hv/greedy_verification.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/hv/hv_go.hpp"
        )

    set(cg_impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/cg/correspondence_grouping.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/cg/hough_3d.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/cg/geometric_consistency.hpp"
        )

    set(srcs
        src/linemod.cpp
        src/quantizable_modality.cpp
        src/dotmod.cpp
        src/mask_map.cpp
        src/hv/occlusion_reasoning.cpp
        src/hv/hv_papazov.cpp
        src/hv/hv_go.cpp
        src/hv/greedy_verification.cpp
        src/cg/hough_3d.cpp
        src/cg/geometric_consistency.cpp
        src/ransac_based/obj_rec_ransac.cpp
        src/ransac_based/model_library.cpp
        src/ransac_based/orr_octree.cpp
        src/ransac_based/orr_octree_zprojection.cpp
		    src/implicit_shape_model.cpp
        )
        
    if (HAVE_METSLIB)
        set(metslib_incs "")
    else(HAVE_METSLIB)
        set(metslib_incs
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/abstract-search.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/local-search.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/mets.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/metslib_config.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/model.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/observer.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/simulated-annealing.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/tabu-search.hh"
            "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/termination-criteria.hh"
            )
    endif(HAVE_METSLIB)

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs} ${ransac_based_incs} ${ransac_based_impl_incs} ${hv_incs} ${hv_impl_incs} ${cg_incs} ${cg_impl_incs} ${metslib_incs})
    target_link_libraries("${LIB_NAME}" pcl_common pcl_kdtree pcl_octree pcl_search pcl_features pcl_registration pcl_sample_consensus pcl_filters pcl_io)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")
    # Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ransac_based" ${ransac_based_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/hv" ${hv_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/cg" ${cg_incs})
    
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/ransac_based" ${ransac_based_impl_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/hv" ${hv_impl_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/cg" ${cg_impl_incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/linemod" ${LINEMOD_INCLUDES})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/linemod" ${LINEMOD_IMPLS})

endif(build)

=== debian/changelog ===
pcl (1.7.2-14build1) xenial; urgency=medium

  * No-change rebuild for qhull transition.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Feb 2016 07:59:20 +0100

pcl (1.7.2-14) unstable; urgency=medium

  * Add patch for gcc6 (Closes: #812015)
  * Move pcl-tools to section science.

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Sat, 23 Jan 2016 19:30:45 +0100

pcl (1.7.2-13) unstable; urgency=medium

  * Fix dependencies
  * Add patch to fix compilation error if no QVTK is found

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Fri, 16 Oct 2015 17:07:50 +0200

pcl (1.7.2-12) unstable; urgency=medium

  * Fix syntax in rules file
  * libvtk6-qt-dev is not available on arm

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Sun, 11 Oct 2015 16:56:06 +0200

pcl (1.7.2-11) unstable; urgency=medium

  [ Leopold Palomo-Avellaneda ]
  * Add parallel build in some Archs (!=32 bits).
    Closes: #799218

  [ Jochen Sprickerhof ]
  * Add patch for Eigen build error
  * Switch to VTK6 (Closes: #798171).

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Sat, 10 Oct 2015 23:51:16 +0200

pcl (1.7.2-10) unstable; urgency=medium

  * Fix an other FTBFS on ppc64el

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Tue, 01 Sep 2015 09:41:28 +0200

pcl (1.7.2-9) unstable; urgency=medium

  * Add patches for FTBFS with gcc5 (closes #795525)
  * Fix FTBFS on ppc64el, thanks to ChriSopht in #eigen
  * Add mips* as supported OpenNI architectures

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Mon, 17 Aug 2015 12:05:12 +0200

pcl (1.7.2-8) unstable; urgency=medium

  * Appy ggc-min-expand+disable-WITH_DOCS.diff (Closes: #780582), Thanks Dejan
    Latinovic.
  * Update architectures on libopenni-dev dependency

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Tue, 09 Jun 2015 10:55:56 +0200

pcl (1.7.2-7) unstable; urgency=medium

  * Added patch to solve sometimes FTBFS. Patch proposed by
    James Cowgill (thanks!!!). Closes: #779183

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 25 Feb 2015 23:12:50 +0100

pcl (1.7.2-6) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Remove --parallel from dh to fix build on i386 buildd.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 02 Dec 2014 08:29:43 +0100

pcl (1.7.2-5) unstable; urgency=medium

  [Leopold Palomo-Avellaneda]
  * Reverted Multi-arch field for libpcl-apps1.7.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Thu, 27 Nov 2014 18:14:40 +0100

pcl (1.7.2-4) unstable; urgency=medium

  [Leopold Palomo-Avellaneda]
  * Added missing Multi-arch field for libpcl-apps1.7.
  * Removing Multi-Arch of libpcl-dev. Closes: #770503

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 24 Nov 2014 12:27:06 +0100

pcl (1.7.2-3) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Change openni-dev to libopenni, Closes: #768953
  * Build without OpenNI when it's not available. It opens
    the number of architectures where it could be built. Closes: #769883
  * Fix PCLConfig.cmake (patch taken from Fedora). Closes: #770029

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 11 Nov 2014 15:34:43 +0100

pcl (1.7.2-2) unstable; urgency=medium

  [Leopold Palomo-Avellaneda]
  * Change install place for cmake files. Closes: #766685
  * Added dh-exec (>=0.3) dependecy.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Sun, 26 Oct 2014 09:46:18 +0100

pcl (1.7.2-1) unstable; urgency=medium

  [Thomas Moulard]
  * Initial debianization.

  [Leopold Palomo-Avellaneda]
  * Initial release. (Closes: #703579)
  * Worked from the initial debianization from Thomas Moulard.
    Jochen Sprickerhof and myself added as uploaders.
  * Added libvtk5-qt4-dev, libopenni-sensor-primesense-dev, python-vtk,
    libvtk5-qt4-dev, libqt4-opengl-dev, python-sphinx, libusb-1.0-0-dev build
    dependencies.
  * Deleted pkg-kde-tools dependency.
  * Relaxed boost dependencies.
  * Added some applications to be build: app_modeler, app_point_cloud_editor,
    in_hand_scanner in rules.
  * Renamed libpcl-tools to pcl-tools.
  * Added manpages ...
  * Added libjs-jquery dependency to calm lintian.

  [Jochen Sprickerhof]
  * Fix license file.
  * Clean up debian/rules.
  * Update Standards-Version (no changes).
  * Fix hidden dependencies with glut and OpenGL of pcl-tools.
  * Cosmetic changes.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 06 Oct 2014 09:30:55 +0200

=== debian/control ===
Source: pcl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
	   Jochen Sprickerhof <debian@jochen.sprickerhof.de>,
	   Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: extra
Build-Depends: debhelper (>= 9), dh-exec (>=0.3),
               cmake,
	       python-sphinx,
	       libboost-system-dev,
	       libboost-filesystem-dev,
	       libboost-thread-dev, 
	       libboost-date-time-dev,
	       libboost-iostreams-dev,
	       libeigen3-dev,
	       libflann-dev,
	       libvtk6-dev,
	       libqhull-dev,
	       libopenni-dev [amd64 arm64 armel armhf i386 mips mipsel powerpc ppc64el],
	       libqt5opengl5-dev,
	       libqt4-opengl-dev,
	       libusb-1.0-0-dev,
	       freeglut3-dev, 
	       libxmu-dev,
	       libxi-dev,
	       libvtk6-qt-dev [!armel !armhf]
Build-Depends-Indep: doxygen,
		     doxygen-latex
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/pcl.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/pcl.git
Homepage: http://www.pointclouds.org/

Package: libpcl-dev
Architecture: any
Section: libdevel
Depends: libboost-all-dev,
	 libeigen3-dev,
	 libflann-dev,
	 libvtk6-dev,
	 libqhull-dev,
	 libvtk6-qt-dev [!armel !armhf],
	 libopenni-dev [amd64 arm64 armel armhf i386 mips mipsel powerpc ppc64el],
         libpcl1.7 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libpcl-doc
Description: Point Cloud Library - development files
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains development files (headers and shared library
 symbolic link).

Package: libpcl1.7
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
	 libpcl-apps1.7,
	 libpcl-common1.7,
	 libpcl-features1.7,
	 libpcl-filters1.7,
	 libpcl-io1.7,
	 libpcl-kdtree1.7,
	 libpcl-keypoints1.7,
	 libpcl-octree1.7,
	 libpcl-outofcore1.7,
	 libpcl-people1.7,
	 libpcl-recognition1.7,
	 libpcl-registration1.7,
	 libpcl-sample-consensus1.7,
	 libpcl-search1.7,
	 libpcl-segmentation1.7,
	 libpcl-surface1.7,
	 libpcl-tracking1.7,
	 libpcl-visualization1.7 
Description: Point Cloud Library -- metapackage
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.

Package: libpcl1.7-dbg
Architecture: any
Section: debug
Depends: libpcl1.7 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Point Cloud Library - debugging symbols
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the debugging symbols for the shared libraries.

Package: libpcl-common1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - common library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL common library.

Package: libpcl-apps1.7
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: Point Cloud Library - apps library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending 
 on PCL apps.

Package: libpcl-features1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - features library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL features library.

Package: libpcl-filters1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - filters library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL filters library.

Package: libpcl-io1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - I/O library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL io.

Package: libpcl-kdtree1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - kdtree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL kdtree library.

Package: libpcl-keypoints1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - keypoints library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL keypoints library.

Package: libpcl-octree1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - octree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL octree library.

Package: libpcl-registration1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - registration library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL registration library.

Package: libpcl-sample-consensus1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - sample consensus library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL sample consensus library.

Package: libpcl-search1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - search library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL search library.

Package: libpcl-segmentation1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - segmentation library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL segmentation library.

Package: libpcl-surface1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - surface library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL surface library.

Package: libpcl-tracking1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - tracking library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL tracking library.

Package: libpcl-visualization1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - visualization library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL visualization library.



Package: libpcl-outofcore1.7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
	 ${misc:Depends}
Description: Point Cloud Library - outofcore library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .

=== debian/rules ===
#!/usr/bin/make -f

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	CXXFLAGS+=--param ggc-min-expand=20
endif

BUILD_DOC = $(if $(shell dh_listpackages | grep libpcl-doc),-DWITH_DOCS=ON)

# Multiarch.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# Num bits
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)

ifeq ($(DEB_HOST_ARCH_BITS),32)
  PARALLEL=
else
  PARALLEL=--parallel
endif

.PHONY: override_dh_auto_configure \
	override_dh_install \
	override_dh_installchangelogs \
	override_dh_strip

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DLIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)"		\
	-DCMAKE_SKIP_RPATH=ON						\
	-DBUILD_TESTS=OFF -DBUILD_apps=ON -DBUILD_common=ON		\
	-DBUILD_examples=ON -DBUILD_features=ON -DBUILD_filters=ON	\
	-DBUILD_geometry=ON -DBUILD_global_tests=OFF -DBUILD_io=ON	\
	-DBUILD_kdtree=ON -DBUILD_keypoints=ON -DBUILD_octree=ON	\
	-DBUILD_registration=ON -DBUILD_sample_consensus=ON		\
	-DBUILD_search=ON -DBUILD_segmentation=ON -DBUILD_surface=ON	\
	-DBUILD_tools=ON -DBUILD_tracking=ON -DBUILD_visualization=ON   \
	-DBUILD_apps_cloud_composer=OFF -DBUILD_apps_modeler=ON            \
	-DBUILD_apps_point_cloud_editor=ON -DBUILD_apps_in_hand_scanner=ON \
	$(BUILD_DOC)

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/libpcl1.7-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/libpcl1.7-dbg/
	
	@for i in pcl_concatenate_points_pcd pcl_grabcut_2d \
		pcl_elch pcl_dinast_grabber pcl_hdl_grabber \
		pcl_icp pcl_icp2d pcl_lum pcl_manual_registration pcl_match_linemod_template \
		pcl_multiscale_feature_persistence_example pcl_ndt2d pcl_ndt3d pcl_ni_agast \
		pcl_ni_linemod pcl_ni_susan pcl_nn_classification_example \
		pcl_obj_rec_ransac_hash_table pcl_openni_grabber_depth_example \
		pcl_openni_grabber_example pcl_openni_mobile_server \
		pcl_openni_organized_multi_plane_segmentation \
		pcl_openni_passthrough pcl_openni_shift_to_depth_conversion \
		pcl_openni_voxel_grid pcl_organized_segmentation_demo pcl_outofcore_print \
		pcl_outofcore_process pcl_pcd_image_viewer \
		pcl_pcd_organized_multi_plane_segmentation pcl_pcd_video_player \
		pcl_point_cloud_editor pcl_pyramid_surface_matching pcl_radius_filter \
		pcl_statistical_multiscale_interest_region_extraction_example \
		pcl_registration_visualizer pcl_surfel_smoothing_test \
		pcl_timed_trigger_test pcl_viewer pcl_virtual_scanner \
		pcl_voxel_grid_occlusion_estimation pcl_compute_hausdorff \
		pcl_generate pcl_grid_min pcl_in_hand_scanner pcl_local_max \
		pcl_morph pcl_ni_trajkovic pcl_obj2pcd pcl_offline_integration 	\
		pcl_openni_klt pcl_progressive_morphological_filter \
		pcl_openni_organized_multi_plane_segmentation; do \
	cmd="dh_link -p pcl-tools usr/share/man/man1/pcl_pointclouds.1 usr/share/man/man1/$$i.1"; \
	echo $$cmd; $$cmd; \
	done
		
	dh_install --list-missing

override_dh_strip:
	dh_strip -a --dbg-package=libpcl1.7-dbg

#override_dh_shlibdeps:
#	dh_shlibdeps -v -Xusr/bin/pcl_* -Lpcl-tools -l:$(CURDIR)/debian/usr/lib/${DEB_HOST_MULTIARCH}/cloud_composer_plugins: -ppcl --- -xpcl-tools -v

override_dh_installchangelogs:
	dh_installchangelogs -plibpcl-common1.7 CHANGES.md
	# Creating dh_links to share the same file
	@for i in libpcl-dev libpcl1.7 libpcl1.7-dbg libpcl-apps1.7 \
		libpcl-features1.7 libpcl-filters1.7 libpcl-io1.7 libpcl-kdtree1.7 \
		libpcl-keypoints1.7 libpcl-octree1.7 libpcl-registration1.7 \
		libpcl-sample-consensus1.7 libpcl-search1.7 libpcl-segmentation1.7 \
		libpcl-surface1.7 libpcl-tracking1.7 libpcl-visualization1.7 \
		libpcl-outofcore1.7 libpcl-people1.7 libpcl-recognition1.7 \
		pcl-tools libpcl-doc; do \
	cmd="dh_link -p$$i usr/share/doc/libpcl-common1.7/changelog.gz usr/share/doc/$$i/changelog.gz"; \
	echo $$cmd; $$cmd; \
	done
	dh_installchangelogs


%:
	dh  $@ $(PARALLEL) --builddirectory=build


get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
# Watch control file for uscan
version=3
#opts=uversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2/ \ 
#https://github.com/PointCloudLibrary/pcl/releases .*/pcl-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

opts="uversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2/" \
https://github.com/PointCloudLibrary/pcl/releases .*/pcl-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
